
Public Class ThisDocument

    Private WithEvents dp As DateTimePicker
    Private WithEvents tx As TextBox
    Private WithEvents btnXMLIns As Button
    Private txtProduct As TextBox
    Private txtQuantity As TextBox

#Region "ThisDoc Startup und Shutdown"
    Private Sub ThisDocument_Startup(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Startup
    End Sub

    Private Sub ThisDocument_Shutdown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shutdown
    End Sub
#End Region

#Region "OrderRequired_DateNode"
    Private Sub OrderRequired_DateNode_ContextEnter(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Word.ContextChangeEventArgs) Handles OrderRequired_DateNode.ContextEnter
        dp = New DateTimePicker
        Me.ActionsPane.Controls.Add(dp)
    End Sub

    Private Sub OrderRequired_DateNode_ContextLeave(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Word.ContextChangeEventArgs) Handles OrderRequired_DateNode.ContextLeave
        Me.ActionsPane.Controls.Remove(dp)
    End Sub

    Private Sub dp_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles dp.ValueChanged
        OrderRequired_DateNode.Text = dp.Value.ToLongDateString
    End Sub
#End Region

#Region "OrderShip_NameNode"
    Private Sub OrderShip_NameNode_ContextEnter(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Word.ContextChangeEventArgs) Handles OrderShip_NameNode.ContextEnter
        tx = New TextBox
        Me.ActionsPane.Controls.Add(tx)
    End Sub

    Private Sub OrderShip_NameNode_ContextLeave(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Word.ContextChangeEventArgs) Handles OrderShip_NameNode.ContextLeave
        Me.ActionsPane.Controls.Remove(tx)
    End Sub

    Private Sub tx_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tx.TextChanged
        OrderShip_NameNode.Text = tx.Text
    End Sub
#End Region

    Private Sub btnXMLIns_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnXMLIns.Click

        Dim r As Word.Range
        Dim xN As Word.XMLNode
        Dim xND As Word.XMLNode
        Dim xNDD As Word.XMLNode

        xN = OrderOrder_DetailsNodes.Item(OrderOrder_DetailsNodes.Count) 'letztes Order Detail

        r = xN.Range.Next(Word.WdUnits.wdParagraph, 1) 'Nchster Absatz
        r.Select()

        Me.Application.Selection.InsertParagraphAfter()
        Me.Application.Selection.MoveLeft()
        r = Me.Application.Selection.Range


        xND = OrdersOrderNode.ChildNodeSuggestions("Order_Details").Insert(CType(r, Object))
        xNDD = xND.ChildNodeSuggestions("Quantity").Insert()
        xNDD.Text = txtQuantity.Text

        xNDD = xND.ChildNodeSuggestions("Product").Insert()
        xNDD.Text = txtProduct.Text

        Me.Application.Selection.MoveLeft(Word.WdUnits.wdCharacter, 5)
        Me.Application.Selection.MoveDown(Word.WdUnits.wdLine, 1)

    End Sub

    Private Sub OrderOrder_DetailsNodes_ContextEnter(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Word.ContextChangeEventArgs) Handles OrderOrder_DetailsNodes.ContextEnter
        Dim l1, l2 As New Label

        l1.Text = "Produkt:"
        Me.ActionsPane.Controls.Add(l1)

        txtProduct = New TextBox
        Me.ActionsPane.Controls.Add(txtProduct)

        l2.Text = "Menge"
        Me.ActionsPane.Controls.Add(l2)

        txtQuantity = New TextBox
        Me.ActionsPane.Controls.Add(txtQuantity)

        btnXMLIns = New Button()
        btnXMLIns.Text = "New Order Detail"
        Me.ActionsPane.Controls.Add(btnXMLIns)

    End Sub

    Private Sub OrderOrder_DetailsNodes_ContextLeave(ByVal sender As Object, ByVal e As Microsoft.Office.Tools.Word.ContextChangeEventArgs) Handles OrderOrder_DetailsNodes.ContextLeave
        Me.ActionsPane.Controls.Clear()

        'Me.ActionsPane.Controls.Remove(btnXMLIns)
        'Me.ActionsPane.Controls.Remove(txtProduct)
        'Me.ActionsPane.Controls.Remove(txtQuantity)
    End Sub
End Class
