Imports Microsoft.VisualStudio.Tools.Applications.Runtime 'Referenz setzen !!
Imports System.Xml.Serialization

Module Module1
    Private FileName As String = "C:\_TechTalk\Demos\04-DataIslands\DI-Kunde\bin\Debug\DI-Kunde.xls"

    Sub Main()

        ReadCachedItems(FileName)
        ReadCachedData()
        ClearCache()
        ReadCachedData()
    End Sub

    Sub ClearCache()
        'entfernt nur die Daten aus dem Cache
        Using srvDoc As ServerDocument = New ServerDocument(FileName)
            srvDoc.CachedData.ClearData()
            srvDoc.Save()
            srvDoc.Close()
        End Using
    End Sub

    'liest die Daten
    Sub ReadCachedData()

        Using srvDoc As ServerDocument = New ServerDocument(FileName)

            Dim dataHostItem1 As CachedDataHostItem = srvDoc.CachedData.HostItems("DI_Kunde.Tabelle1")
            Dim dataItem1 As CachedDataItem = dataHostItem1.CachedData("derKunde")

            If dataItem1.Xml Is Nothing Then
                MsgBox("Keine Daten im Cache gefunden!")
                Dim derKunde As New DI_Kunde_Lib.CKunde

                derKunde.Name = "Onix"
                derKunde.Bestellung = "Neu vom Server " + Now.ToShortTimeString
                dataItem1.SerializeDataInstance(derKunde)
                srvDoc.Save()
                srvDoc.Close()
            Else
                Dim serializer As XmlSerializer = New XmlSerializer(GetType(DI_Kunde_Lib.CKunde))
                Dim xmlData As String = dataItem1.Xml

                Using reader As New IO.StringReader(xmlData)
                    'Objekt deserialisieren
                    Dim derKunde As DI_Kunde_Lib.CKunde = CType(serializer.Deserialize(reader), DI_Kunde_Lib.CKunde)

                    ' Daten verarbeiten
                    MsgBox("Daten im Dokument gefunden:" + vbCrLf + derKunde.Bestellung + vbCrLf + derKunde.Name)

                    'Daten ndern
                    derKunde.Name = "Tanyuki"
                    derKunde.Bestellung = "Server " + Now.ToShortTimeString
                    dataItem1.SerializeDataInstance(derKunde)
                    srvDoc.Save()
                    srvDoc.Close()
                End Using
            End If

        End Using
    End Sub

    'liest die Items, die sich im Cache befinden
    Private Sub ReadCachedItems(ByVal fileName As String)
        If ServerDocument.IsCustomized(fileName) Then
            Dim serverDocument1 As ServerDocument = Nothing
            Try
                serverDocument1 = New ServerDocument(fileName, True)
                Dim stringBuilder1 As New System.Text.StringBuilder()

                ' Display all of the cached data items 
                ' in the document.
                Dim hostItem1 As CachedDataHostItem
                For Each hostItem1 In serverDocument1.CachedData.HostItems
                    stringBuilder1.Append(vbLf + "Namespace and class: ")
                    stringBuilder1.Append(hostItem1.Id + vbLf)
                    Dim dataItem1 As CachedDataItem
                    For Each dataItem1 In hostItem1.CachedData
                        stringBuilder1.Append("     Data item: ")
                        stringBuilder1.Append(dataItem1.Id + vbLf)
                    Next dataItem1
                Next hostItem1
                MsgBox(stringBuilder1.ToString())
            Finally
                If Not serverDocument1 Is Nothing Then
                    serverDocument1.Close()
                End If
            End Try
        Else
            MsgBox("The specified document is not customized.")
        End If
    End Sub

End Module
