Imports Microsoft.VisualStudio.Tools.Applications.Runtime

Public Class frmServer

    Dim theCachedDataSet As DataSet
    Dim srvDoc As ServerDocument = Nothing

    Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click

        Try
            srvDoc = New ServerDocument(txtDocPath.Text)

            lstCachedData.Items.Clear()
            lstHostItems.Items.Clear()

            For Each hi As CachedDataHostItem In srvDoc.CachedData.HostItems
                lstHostItems.Items.Add(hi.Id)
            Next

        Catch ex As Exception
            MsgBox(ex.Message)
            If Not srvDoc Is Nothing Then
                srvDoc.Close()
            End If
        End Try

    End Sub

    Private Sub lstHostItems_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstHostItems.SelectedIndexChanged
        Dim strHostItemID As String = lstHostItems.SelectedItem.ToString
        lstCachedData.Items.Clear()
        For Each cd As CachedDataItem In srvDoc.CachedData.HostItems(strHostItemID).CachedData
            lstCachedData.Items.Add(cd.Id)
        Next
    End Sub

    Private Sub btnShowData_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnShowData.Click
        Dim strHostItemID As String = lstHostItems.SelectedItem.ToString
        Dim strCachedDataItemID As String = lstCachedData.SelectedItem.ToString

        Dim cdHostItem As CachedDataHostItem = srvDoc.CachedData.HostItems(strHostItemID)

        Dim cDataItem As CachedDataItem = cdHostItem.CachedData(strCachedDataItemID)

        Dim schemaReader As New System.IO.StringReader(cDataItem.Schema)
        Dim xmlReader As New System.IO.StringReader(cDataItem.Xml)

        theCachedDataSet = New DataSet
        theCachedDataSet.ReadXmlSchema(schemaReader)
        theCachedDataSet.ReadXml(xmlReader)

        DataGrid1.DataSource = theCachedDataSet


    End Sub
End Class
