Imports System.Configuration
Imports System.Xml
Imports System.IO
Imports System.Data.SqlClient
Imports System.Web.Services

<WebService(Namespace:="urn:Microsoft.Search")> _
Public Class QueryProcessor
    Inherits System.Web.Services.WebService

    Private pathPhysical As String = HttpContext.Current.Server.MapPath(".")
    Private pathHTTP As String = ConfigurationSettings.AppSettings("ServerPath") + _
        HttpContext.Current.Request.ApplicationPath + "/"

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region

    <WebMethod()> Public Function Query(ByVal queryXml As String) As String
        Dim productKeyword As String
        Dim requestXml As New XmlDocument
        Dim responseWrapper As New XmlDocument

        If queryXml.Length = 0 Then
            Return ""
        End If

        requestXml.LoadXml(queryXml)

        Dim nsmRequest As New XmlNamespaceManager(requestXml.NameTable)
        nsmRequest.AddNamespace("ns", "urn:Microsoft.Search.Query")
        nsmRequest.AddNamespace("oc", "urn:Microsoft.Search.Query.Office.Context")

        productKeyword = requestXml.SelectSingleNode("//ns:QueryText", nsmRequest).InnerText

        responseWrapper.Load(pathPhysical + "\\ResponseWrapper.xml")

        Dim nsmResponse As New XmlNamespaceManager(responseWrapper.NameTable)
        nsmResponse.AddNamespace("ns", "urn:Microsoft.Search.Response")

        responseWrapper.SelectSingleNode("//ns:Results", nsmResponse).InnerXml = QueryNorthwind(productKeyword)
        Return responseWrapper.InnerXml.ToString()
    End Function

    Private Function QueryNorthwind(ByVal productKeyword As String) As String
        Dim responseQuery As StringWriter = New StringWriter
        Dim xtw As XmlTextWriter = New XmlTextWriter(responseQuery)
        Dim drProducts As SqlDataReader
        Dim prodCount As Integer

        With xtw
            Try
                drProducts = DataTier.SearchProducts(productKeyword)

                ' Begin the content portion of the XML response.
                .WriteStartElement("Content", "urn:Microsoft.Search.Response.Content")

                'Insert Image
                .WriteStartElement("Image")
                .WriteAttributeString("source", pathHTTP + "/logo.gif")
                .WriteEndElement()

                ' Add matching product info.
                While drProducts.Read
                    prodCount += 1
                    If prodCount = 1 Then
                        .WriteElementString("P", "Your search returned the following products:")
                    End If

                    'Product Name
                    .WriteStartElement("Heading")

                    .WriteAttributeString("collapsible", "true")
                    .WriteAttributeString("collapsed", "false")
                    .WriteElementString("Text", drProducts("productname"))

                    .WriteStartElement("Char")
                    .WriteAttributeString("light", "true")
                    .WriteString(" (ID# " & drProducts("productid") & ")")
                    .WriteEndElement() 'Char

                    '==== Product Details Table ====
                    .WriteStartElement("Tabular")

                    'Category
                    .WriteStartElement("Record")
                    .WriteElementString("Name", "Category")
                    .WriteElementString("Value", drProducts("categoryname"))
                    .WriteEndElement() 'Category Record

                    'Unit Cost
                    .WriteStartElement("Record")
                    .WriteElementString("Name", "Unit Cost")
                    .WriteElementString("Value", Format(drProducts("unitprice"), "Currency"))
                    .WriteEndElement() 'Unit Cost Record

                    'Units In Stock
                    .WriteStartElement("Record")
                    .WriteElementString("Name", "Qty Per Unit")
                    .WriteElementString("Value", drProducts("quantityperunit"))
                    .WriteEndElement() 'Units in Stock Record

                    'Supplier
                    .WriteStartElement("Record")
                    .WriteElementString("Name", "Supplier")
                    .WriteElementString("Value", drProducts("companyname"))
                    .WriteEndElement() 'Supplier Record

                    .WriteEndElement() 'Tabular
                    '===== End Product Details Table =====

                    '===== Actions Smart Tag ===== 
                    .WriteStartElement("Actions")

                    .WriteStartElement("Insert")
                    .WriteElementString("Text", "Insert Details")
                    .WriteEndElement() 'Insert

                    .WriteStartElement("Copy")
                    .WriteElementString("Text", "Copy Details")
                    .WriteEndElement() 'Copy

                    .WriteElementString("Data", _
                        drProducts("productname") & " (" & _
                        "ID: " & drProducts("productid") & "; " & _
                        "Price: " & Format(drProducts("unitprice"), "Currency") & "; " & _
                        "Supplier: " & drProducts("companyname") & ")")

                    .WriteEndElement() 'Actions

                    'Advanced product search link
                    .WriteStartElement("Hyperlink")
                    .WriteAttributeString("url", "http://www.google.com/search?q=northwind+" + drProducts("productname"))
                    .WriteElementString("Text", "Continue product search at Google.com ...")
                    .WriteEndElement()

                    .WriteEndElement() 'Heading
                End While

                If prodCount = 0 Then
                    .WriteElementString("P", "Your search returned 0 products. Please try a new keyword.")
                End If

            Catch exp As Exception
                Return ""
            Finally
                If Not drProducts Is Nothing Then
                    drProducts.Close()
                End If
            End Try

            .WriteEndElement() 'Content.
            .Flush()
        End With

        Return responseQuery.ToString()
    End Function
End Class
