Imports System.Configuration 'Lesen der WebConfig
Imports System.Web.Services
Imports System.Xml          ' needed to read and create XML packets
Imports System.IO           ' needed to construct the XML packet in memory

'http://localhost/PokemonRS/Pokemon.asmx
<WebService(Namespace:="urn:Microsoft.Search")> _
Public Class Pokemon
    Inherits System.Web.Services.WebService

    Private m_Pokemons As CPokemons = New CPokemons

    Private pathHTTP As String = ConfigurationSettings.AppSettings("ServerPath") + _
        HttpContext.Current.Request.ApplicationPath + "/"


#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region

#Region "Query"
    <WebMethod()> _
    Public Function Query(ByVal queryXml As String) As String

        Dim queryTerm As String
        Dim ioMemStream As New MemoryStream
        Dim myXMLwriter As New XmlTextWriter(ioMemStream, Nothing)

        With myXMLwriter
            .Indentation = 4
            .IndentChar = CType(" ", Char)
            .WriteStartDocument()

            .WriteStartElement("ResponsePacket", ns:="urn:Microsoft.Search.Response")
            .WriteAttributeString("revision", value:="1")

            .WriteStartElement("Response")

            ' this GUID must match the Registration Service ID
            .WriteAttributeString("domain", value:="{942F685E-0935-42c8-80C5-95DB0D129910}")

            .WriteElementString("QueryID", "{690EF6D8-575D-4897-8F30-293E175C1B99}")
            .WriteStartElement("Range")
            .WriteStartElement("Results")


            .WriteStartElement("Content", ns:="urn:Microsoft.Search.Response.Content")
            '----------------------------------------------------------------
            .WriteElementString("P", "Folgende Pokemon wurden gefunden:")

            'Bild 
            .WriteStartElement("Image source=""" + pathHTTP + "Pokemon/Gengar.gif"" ")
            .WriteEndElement()

            .WriteElementString("P", "Name: " + m_Pokemons.Name)

            '===== Begin Product Details Table =====
            .WriteStartElement("Tabular")

            'Category
            .WriteStartElement("Record")
            .WriteElementString("Name", "Type")
            .WriteElementString("Value", m_Pokemons.Type)
            .WriteEndElement() 'Category Record

            'Unit Cost
            .WriteStartElement("Record")
            .WriteElementString("Name", "Skill")
            .WriteElementString("Value", m_Pokemons.Skill)
            .WriteEndElement() 'Unit Cost Record


            .WriteEndElement() 'Tabular
            '===== End Product Details Table =====

            '===== Actions Smart Tag ===== 
            .WriteStartElement("Actions")

            'urn:schemas-microsoft-com:msdnmag#mlb
            .WriteStartElement("Custom")
            .WriteAttributeString("xmlns:hw", "urn:schemas-microsoft-com:msdnmag")
            .WriteElementString("hw:mlb", "Sox")
            .WriteEndElement() 'Custom


            .WriteStartElement("Insert")
            .WriteElementString("Text", "Details einfgen")
            .WriteEndElement() 'Insert

            .WriteStartElement("Copy")
            .WriteElementString("Text", "Details in die Zwischenablage")
            .WriteEndElement() 'Copy

            .WriteElementString("Data", _
                m_Pokemons.Name & " (" & _
                "Skill: " & m_Pokemons.Skill & "; " & _
                "Type: " & m_Pokemons.Type & "; " & _
                "Bild: " & m_Pokemons.PicName & ")")

            .WriteEndElement() 'Actions

            'Advanced product search link
            .WriteStartElement("Hyperlink")
            .WriteAttributeString("url", "http://www.google.com/search?q=" + m_Pokemons.Name)
            .WriteElementString("Text", "Continue product search at Google.com ...")
            .WriteEndElement()

            .WriteElementString("HorizontalRule", "")

            .WriteEndElement() ' Content

            .WriteStartElement("Content", ns:="urn:Microsoft.Search.Response.Content")
            .WriteElementString("P", "I heard you2!")
            .WriteElementString("HorizontalRule", "")
            .WriteEndElement() ' Content

            .WriteStartElement("Content", ns:="urn:Microsoft.Search.Response.Content")
            .WriteElementString("P", "I heard you2!")
            .WriteEndElement() ' Content

            .WriteEndElement() ' Results
            .WriteEndElement() ' Range

            .WriteElementString("Status", "SUCCESS")

            .WriteEndElement() ' Response
            .WriteEndElement() ' ResponsePacket
            .WriteEndDocument()
        End With

        myXMLwriter.Flush()
        ioMemStream.Flush()
        ioMemStream.Position = 0
        Dim iostReader As New IO.StreamReader(ioMemStream)
        Return iostReader.ReadToEnd.ToString
    End Function
#End Region

#Region "Register"
    <WebMethod()> _
    Public Function Registration(ByVal regXML As String) As String
        Dim ioMemStream As New MemoryStream
        Dim myXMLwriter As New XmlTextWriter(ioMemStream, Nothing)

        With myXMLwriter
            .Indentation = 4
            .IndentChar = CType(" ", Char)
            .WriteStartDocument()
            .WriteStartElement("ProviderUpdate", _
             ns:="urn:Microsoft.Search.Registration.Response")
            .WriteElementString("Status", "SUCCESS")
            .WriteStartElement("Providers")
            .WriteStartElement("Provider")

            .WriteElementString("Message", "Dieses Nachschlagewerk bietet Ihnen Informationen zu Pokemons an." + vbCrLf + "Marcel Gnoth, 2005, www.gnoth.net")
            .WriteElementString("Id", _
             "{E545CFA2-E5AC-408a-92D9-E8C8487E6D69}")
            .WriteElementString("Name", "Pokemon Research Center")
            .WriteElementString("QueryPath", "http://localhost/PokemonRS/Pokemon.asmx")
            .WriteElementString("RegistrationPath", "http://localhost/PokemonRS/Pokemon.asmx")
            .WriteElementString("Type", "SOAP")
            .WriteStartElement("Services")
            .WriteStartElement("Service")
            .WriteElementString("Id", "{942F685E-0935-42c8-80C5-95DB0D129910}")
            .WriteElementString("Name", "Pokemon Enzyklopdie")
            .WriteElementString("Description", "Ein einfaches Research Service Sample, das die Suche nach Pokemons ermglicht.")
            .WriteElementString("Copyright", _
             "Marcel Gnoth, www.gnoth.net, (c) 2005.")
            .WriteElementString("Display", "On")
            .WriteElementString("Category", "INTRANET_GENERAL")

            .WriteEndElement()  ' Service
            .WriteEndElement()  ' Services
            .WriteEndElement()  ' Provider
            .WriteEndElement()  ' Providers
            .WriteEndElement()  ' ProviderUpdate
            .WriteEndDocument()
        End With

        myXMLwriter.Flush()

        ioMemStream.Flush()
        ioMemStream.Position = 0
        Dim iostReader As New IO.StreamReader(ioMemStream)
        Return iostReader.ReadToEnd.ToString
    End Function
#End Region


End Class
